gUserProps = {}
gUserPropTimes = {}
gPropids = {}
gRestrictedProps = {}

function eventPlayerSpawnProp( userid, propname ) -- We want this to be able to be overridden.
	if hasAccess( userid, ACCESS_PROP_PROTECT ) == true then -- If they have access to avoid this, let them spawn
		return true
	end
	
	propname = string.lower( propname )
	local steamid = _PlayerInfo( userid, "networkid" ) -- We'll track the users by steamid, not userid

	if gUserProps[ steamid ] == nil then
		gUserProps[ steamid ] = {}
		gUserPropTimes[ steamid ] = List.new()
		for i=1, 5 do
			List.pushright( gUserPropTimes[ steamid ], 0 )
		end
		gUserPropTimes[ steamid ].wait_till = nil
	end
	
	if gUserPropTimes[ steamid ].wait_till ~= nil then
		if _CurTime() > gUserPropTimes[ steamid ].wait_till then -- If it's over
			gUserPropTimes[ steamid ].wait_till = nil
		else
			ulx_tsay( userid, "Stop spamming!" )		
			return false
		end
	else
		local first = gUserPropTimes[ steamid ][ gUserPropTimes[ steamid ].first ]
		local last = gUserPropTimes[ steamid ][ gUserPropTimes[ steamid ].last ]
		debug( "first: " .. first )
		if last - first < 5 and first + last > 0 then
			gUserPropTimes[ steamid ].wait_till = _CurTime() + 30
			ulx_tsay( userid, "You may not spawn more than 5 props in 5 seconds, blocked for the next 30 seconds" )
			return false
		end
	end
	
	if gRestrictedProps[ propname ] == nil then
		List.pushright( gUserPropTimes[ steamid ] , _CurTime() )
		List.popleft( gUserPropTimes[ steamid ] )
		return true -- They're allowed to spawn it
	end
	
	if gUserProps[ steamid ][ propname ] == nil then
		gUserProps[ steamid ][ propname ] = 0
	end
	
	if gUserProps[ steamid ][ propname ] < gRestrictedProps[ propname ] then -- If they've spawned less than the max
		gUserProps[ steamid ][ propname ] = gUserProps[ steamid ][ propname ] + 1
		gUserProps[ steamid ].next_prop = propname -- This helps us track the entids
		List.pushright( gUserPropTimes[ steamid ] , _CurTime() )
		List.popleft( gUserPropTimes[ steamid ] )		
		return true
	else
		ulx_tsay( userid, "You're can only spawn " .. gRestrictedProps[ propname ] .. " copy of this prop!" )	
		return false
	end
end

function eventPlayerSpawnRagdoll( userid, propname )
	return eventPlayerSpawnProp( userid, propname )
end

function eventPlayerDuplicateProp( userid, propid )
	local steamid = _PlayerInfo( userid, "networkid" ) -- We'll track the users by steamid, not userid
	
	if gRestrictedProps[ string.lower( _EntGetModel( propid ) ) ] ~= nil and hasAccess( userid, ACCESS_PROP_PROTECT ) == false then
		ulx_tsay( userid, "Sorry, due to a security issue, you can't duplicate this prop." )
		return false
	else
		return true
	end
end

function eventPlayerDuplicateRagdoll( userid, propid )
	return eventPlayerDuplicateProp( userid, propid )
end

-- Here's where we can get the propid from the spawned prop
function eventPlayerPropSpawned( userid, propid )
	if hasAccess( userid, ACCESS_PROP_PROTECT ) == true then -- Protect their prop if they have access
		gPropids[ propid ] = "protected"
		return
	end

	local steamid = _PlayerInfo( userid, "networkid" ) -- We'll track the users by steamid, not userid

	if gUserProps[ steamid ].next_prop == nil then -- If this isn't a prop we're looking out for, return
		return
	end
	
	gPropids[ propid ] = { spawner=steamid, prop_name=gUserProps[ steamid ].next_prop } -- Register this ID
	return
end

function eventPlayerRagdollSpawned( userid, propid )
	return eventPlayerPropSpawned( userid, propid )
end

function onPlayerRemove( userid, propid )
	if gPropids[ propid ] == nil then -- Not one we're concerned about
		return true
	elseif gPropids[ propid ] == "protected" then -- If this is protected
		if hasAccess( userid, ACCESS_PROP_PROTECT ) == true then
			gPropsids[ propid ] = nil -- It's no longer, the id will be recycled
			return true	
		else
			ulx_tsay( userid, "This prop is protected, you may not delete it!" )
			return false
		end
	end
	
	local steamid = _PlayerInfo( userid, "networkid" ) -- We'll track the users by steamid, not userid
	
	gUserProps[ gPropids[ propid ].spawner ][ gPropids[ propid ].prop_name ] = gUserProps[ gPropids[ propid ].spawner ][ gPropids[ propid ].prop_name ] - 1 -- Decrement their ( original spawner ) count by one
	gPropsids[ propid ] = nil -- It's no longer, the id will be recycled
	return true
end

function addRestrictedProp( model, max )
	-- Add error checking here?
	gRestrictedProps[ string.lower( model ) ] = max
end


-- Add props to our restricted list ( USE LINUX DIRECTORY NOTATION '/' AND NOT WINDOWS NOTATION '\' )
-- addRestrictedProp( model, max_copies_allowed )
-- Please note that this will disable duplication of these models due to security issues

addRestrictedProp( "models/props_animated_breakable/smokestack.mdl", 1 )
addRestrictedProp( "models/props_combine/combine_train02a.mdl", 1 )
addRestrictedProp( "models/props_combine/combine_train02b.mdl", 1 )
addRestrictedProp( "models/props_combine/CombineTrain01a.mdl", 1 )
addRestrictedProp( "models/props_trainstation/train001.mdl", 1 )
addRestrictedProp( "models/props_trainstation/train002.mdl", 1 )
addRestrictedProp( "models/props_trainstation/train003.mdl", 1 )
addRestrictedProp( "models/props_trainstation/train005.mdl", 1 )
addRestrictedProp( "models/props_trainstation/train004.mdl", 1 )
addRestrictedProp( "models/props_combine/stasisfield.mdl", 1 )
addRestrictedProp( "models/props_combine/strut_array_01.mdl", 1 )
addRestrictedProp( "models/Cranes/crane_docks.mdl", 1 )
addRestrictedProp( "models/props_c17/statue_horse.mdl", 1 )
addRestrictedProp( "models/alyx.mdl", 2 )

